git-stash.sh 4.8 KB
Newer Older
しらいしななこ 已提交
1 2 3
#!/bin/sh
# Copyright (c) 2007, Nanako Shiraishi

4
USAGE='[  | save | list | show | apply | clear | create ]'
しらいしななこ 已提交
5

6
SUBDIRECTORY_OK=Yes
7
OPTIONS_SPEC=
しらいしななこ 已提交
8 9
. git-sh-setup
require_work_tree
10
cd_to_toplevel
しらいしななこ 已提交
11 12 13 14 15 16 17

TMP="$GIT_DIR/.git-stash.$$"
trap 'rm -f "$TMP-*"' 0

ref_stash=refs/stash

no_changes () {
18
	git diff-index --quiet --cached HEAD -- &&
19
	git diff-files --quiet
しらいしななこ 已提交
20 21 22
}

clear_stash () {
23 24
	if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
	then
E
Emil Medve 已提交
25
		git update-ref -d $ref_stash $current
26
	fi
しらいしななこ 已提交
27 28
}

J
Junio C Hamano 已提交
29
create_stash () {
30 31
	stash_msg="$1"

しらいしななこ 已提交
32 33 34 35
	if no_changes
	then
		exit 0
	fi
36

しらいしななこ 已提交
37
	# state of the base commit
38
	if b_commit=$(git rev-parse --verify HEAD)
しらいしななこ 已提交
39
	then
40
		head=$(git log --no-color --abbrev-commit --pretty=oneline -n 1 HEAD --)
しらいしななこ 已提交
41 42 43 44
	else
		die "You do not have the initial commit yet"
	fi

45
	if branch=$(git symbolic-ref -q HEAD)
しらいしななこ 已提交
46 47 48 49 50 51 52 53
	then
		branch=${branch#refs/heads/}
	else
		branch='(no branch)'
	fi
	msg=$(printf '%s: %s' "$branch" "$head")

	# state of the index
54
	i_tree=$(git write-tree) &&
55
	i_commit=$(printf 'index on %s\n' "$msg" |
56
		git commit-tree $i_tree -p $b_commit) ||
しらいしななこ 已提交
57 58 59 60
		die "Cannot save the current index state"

	# state of the working tree
	w_tree=$( (
61 62
		rm -f "$TMP-index" &&
		cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
しらいしななこ 已提交
63 64
		GIT_INDEX_FILE="$TMP-index" &&
		export GIT_INDEX_FILE &&
65
		git read-tree -m $i_tree &&
66 67
		git add -u &&
		git write-tree &&
しらいしななこ 已提交
68 69 70 71 72
		rm -f "$TMP-index"
	) ) ||
		die "Cannot save the current worktree state"

	# create the stash
73 74 75 76 77 78 79
	if test -z "$stash_msg"
	then
		stash_msg=$(printf 'WIP on %s' "$msg")
	else
		stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
	fi
	w_commit=$(printf '%s\n' "$stash_msg" |
80
		git commit-tree $w_tree -p $b_commit -p $i_commit) ||
しらいしななこ 已提交
81
		die "Cannot record working tree state"
J
Junio C Hamano 已提交
82
}
しらいしななこ 已提交
83

J
Junio C Hamano 已提交
84 85 86 87 88 89 90 91 92 93 94 95
save_stash () {
	stash_msg="$1"

	if no_changes
	then
		echo >&2 'No local changes to save'
		exit 0
	fi
	test -f "$GIT_DIR/logs/$ref_stash" ||
		clear_stash || die "Cannot initialize stash"

	create_stash "$stash_msg"
E
Emil Medve 已提交
96 97 98

	# Make sure the reflog for stash is kept.
	: >>"$GIT_DIR/logs/$ref_stash"
しらいしななこ 已提交
99

100
	git update-ref -m "$stash_msg" $ref_stash $w_commit ||
しらいしななこ 已提交
101
		die "Cannot save the current status"
102
	printf >&2 'Saved "%s"\n' "$stash_msg"
しらいしななこ 已提交
103 104
}

105
have_stash () {
106
	git rev-parse --verify $ref_stash >/dev/null 2>&1
107 108
}

しらいしななこ 已提交
109
list_stash () {
110
	have_stash || return 0
111
	git log --no-color --pretty=oneline -g "$@" $ref_stash -- |
しらいしななこ 已提交
112 113 114 115
	sed -n -e 's/^[.0-9a-f]* refs\///p'
}

show_stash () {
116
	flags=$(git rev-parse --no-revs --flags "$@")
しらいしななこ 已提交
117 118 119 120
	if test -z "$flags"
	then
		flags=--stat
	fi
121
	s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
しらいしななこ 已提交
122

123 124
	w_commit=$(git rev-parse --verify "$s") &&
	b_commit=$(git rev-parse --verify "$s^") &&
125
	git diff $flags $b_commit $w_commit
しらいしななこ 已提交
126 127 128
}

apply_stash () {
129
	git diff-files --quiet ||
しらいしななこ 已提交
130 131
		die 'Cannot restore on top of a dirty state'

132 133 134 135 136 137 138
	unstash_index=
	case "$1" in
	--index)
		unstash_index=t
		shift
	esac

しらいしななこ 已提交
139
	# current index state
140
	c_tree=$(git write-tree) ||
しらいしななこ 已提交
141 142
		die 'Cannot apply a stash in the middle of a merge'

J
Junio C Hamano 已提交
143 144
	# stash records the work tree, and is a merge between the
	# base commit (first parent) and the index tree (second parent).
145 146
	s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
	w_tree=$(git rev-parse --verify "$s:") &&
J
Junio C Hamano 已提交
147 148
	b_tree=$(git rev-parse --verify "$s^1:") &&
	i_tree=$(git rev-parse --verify "$s^2:") ||
しらいしななこ 已提交
149 150
		die "$*: no valid stashed state found"

J
Junio C Hamano 已提交
151 152 153
	unstashed_index_tree=
	if test -n "$unstash_index" && test "$b_tree" != "$i_tree"
	then
154
		git diff-tree --binary $s^2^..$s^2 | git apply --cached
155 156 157 158 159
		test $? -ne 0 &&
			die 'Conflicts in index. Try without --index.'
		unstashed_index_tree=$(git-write-tree) ||
			die 'Could not save index tree'
		git reset
J
Junio C Hamano 已提交
160
	fi
161

しらいしななこ 已提交
162 163 164 165 166 167 168 169 170 171
	eval "
		GITHEAD_$w_tree='Stashed changes' &&
		GITHEAD_$c_tree='Updated upstream' &&
		GITHEAD_$b_tree='Version stash was based on' &&
		export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
	"

	if git-merge-recursive $b_tree -- $c_tree $w_tree
	then
		# No conflict
J
Junio C Hamano 已提交
172 173 174
		if test -n "$unstashed_index_tree"
		then
			git read-tree "$unstashed_index_tree"
175 176
		else
			a="$TMP-added" &&
177
			git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
178 179 180 181
			git read-tree --reset $c_tree &&
			git update-index --add --stdin <"$a" ||
				die "Cannot unstage modified files"
			rm -f "$a"
J
Junio C Hamano 已提交
182 183
		fi
		git status || :
しらいしななこ 已提交
184 185
	else
		# Merge conflict; keep the exit status from merge-recursive
186
		status=$?
J
Junio C Hamano 已提交
187 188 189 190
		if test -n "$unstash_index"
		then
			echo >&2 'Index was not unstashed.'
		fi
191
		exit $status
しらいしななこ 已提交
192 193 194 195 196
	fi
}

# Main command set
case "$1" in
197 198
list)
	shift
しらいしななこ 已提交
199 200 201 202 203 204 205 206 207 208 209
	if test $# = 0
	then
		set x -n 10
		shift
	fi
	list_stash "$@"
	;;
show)
	shift
	show_stash "$@"
	;;
210 211 212 213
save)
	shift
	save_stash "$*" && git-reset --hard
	;;
しらいしななこ 已提交
214 215 216 217 218 219 220
apply)
	shift
	apply_stash "$@"
	;;
clear)
	clear_stash
	;;
J
Junio C Hamano 已提交
221 222 223 224 225 226 227
create)
	if test $# -gt 0 && test "$1" = create
	then
		shift
	fi
	create_stash "$*" && echo "$w_commit"
	;;
しらいしななこ 已提交
228
*)
229
	if test $# -eq 0
230
	then
231 232 233
		save_stash && git-reset --hard
	else
		usage
234 235
	fi
	;;
しらいしななこ 已提交
236
esac